import controlP5.*;

PVector location;
PVector velocity;
Drop mover;
ControlP5 controlP5;
CheckBox graphicsToggle;
int fancyGraphics;

int dropsWanted = 5;
ArrayList drops;
Scenery scenery;

PGraphics window;

float carSpeed = 0;

void setup() {
  size(1024, 768);
  noStroke();
  smooth();
  
  window = createGraphics(width, height, JAVA2D);
  window.beginDraw();
  window.background(128);
  window.endDraw(); 

  drops = new ArrayList();
  scenery = new Scenery();

  controlP5 = new ControlP5(this);
  Slider carSpeedSlider = controlP5.addSlider("carSpeed",0,10,0,200,height - 20,100,10);
  Slider dropsWantedSlider = controlP5.addSlider("dropsWanted",0,100,10,200,height - 60,100,10);
  graphicsToggle = controlP5.addCheckBox("graphicsToggle",20,20);
  graphicsToggle.addItem("Graphics",0);
}

void draw() {
fancyGraphics = round(graphicsToggle.getItem(0).value());

  
  // maintain the drop population
  while (drops.size() < dropsWanted) {
    drops.add(new Drop());
  }

  background(128);
 
 
  scenery.update();
  if(fancyGraphics == 1) scenery.display();
  
  tint(255, 255, 255, 100);
  
  window.beginDraw();
  window.fill(128, 5);
  window.rect(0, 0, width, height);
  window.endDraw();  
  
  if(fancyGraphics == 1) image(window, 0, 0);
  noTint();

  window.beginDraw();
  
  
  for (int i = drops.size() - 1; i >= 0; i--) {
    // load the drop
    Drop drop = (Drop) drops.get(i);

    // update the drop
    drop.update();
    drop.checkEdges();
    drop.display();

    // clean up the dead
    if(drop.killMe) {
      drops.remove(i);
    }

  }
    
  window.endDraw();
  
  
  // check collisions
  for (int i = 0; i < drops.size(); i++) {
    for (int j = 0; j < drops.size(); j++) {
      if(i != j) {
        Drop drop1 = (Drop) drops.get(i);
        Drop drop2 = (Drop) drops.get(j);
        
        if(!drop1.killMe && !drop2.killMe) {
        
          float distance = PVector.dist(drop1.location, drop2.location);
          
          if (distance <  ((drop1.diameter / 2) + (drop2.diameter / 2))) {
            drop1.speedLimit++; // move faster now that we're bigger and heavier
            drop1.diameter += random(1, 5);
            drop2.killMe = true; // the other drop can go now
          }
        
        }
      }
    }
  }

}


